<script setup lang="ts">
// อันนี้รวมในหน้าเดียวเพราะมีปัญหาเรื่องrefFormไม่รู้ว่าจะ
// import { useEmployStore } from '@/stores/employee';
import type { Employee } from '@/types/Employee'
import { nextTick, ref } from 'vue'
import { onMounted } from 'vue'
import type { VForm } from 'vuetify/components'
import SalaryDialog from './SalaryDialog.vue'
import { useLoadingStore } from '@/stores/loading'
import { useEmployStore2 } from '@/stores/employee2'
import employeeService from '@/services/employee'
// const employeeStore = useEmployStore2()
const Employees = ref<Employee[]>([])
//กำหนดหัวData table
const headers = [
  {
    title: 'Employee ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Employee Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Status',
    key: 'status',
    value: (item: any | Employee) => item.status.join(', ')
  },
  {
    title: 'Check In',
    key: 'checkIn',
    value: 'checkIn'
  },
  {
    title: 'Check Out',
    key: 'checkOut',
    value: 'checkOut'
  },
  {
    title: 'Slary',
    key: 'salary',
    value: 'salary'
  },
  { title: '', key: 'actions', sortable: false }
]
const loadingStore = useLoadingStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const initilEmployee: Employee = {
  id: -1,
  name: '',
  tel: '',
  status: ['PartTime'],
  salary: 0,
  dateIn: '',
  checkIn: '',
  checkOut: ''
}
//Employeeที่กำลังแก้ไข
const editedEmployee = ref<Employee>(JSON.parse(JSON.stringify(initilEmployee)))
// ข้อมูล

let editedIndex = -1
let lastId = 5
function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedEmployee.value = Object.assign({}, initilEmployee)
  })
}
async function deleteItemConfirm() {
  closeDelete()
  await deleteEmployee(editedEmployee.value)
}
function editItem(item: Employee) {
  editedEmployee.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Employee) {
  editedEmployee.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedEmployee.value = Object.assign({}, initilEmployee)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return

  closeDialog()
  await saveEmployee(editedEmployee.value)


}

function searchfor(Input: string) {
  Employees.value = Employees.value.filter(function (Employees) {
    return (
      Employees.name.toLowerCase().includes(Input.toLowerCase()) || Employees.tel.includes(Input)
    )
  })
}
const input = ref('')
function extra() {
  searchfor(input.value)
}


//Data Function
async function getEmployees() {
  console.log("เรียกใช้่")
  loadingStore.doLoad()
  const res = await employeeService.getEmployees()
  Employees.value = res.data
  loadingStore.finish()
  console.log("เรียกใช้เสร็จ")
  //มีปัญหาการเรียกใช้
}

async function saveEmployee(employee: Employee) {
  loadingStore.doLoad()
  if (employee.id < 0) { //Add New
    const res = await employeeService.addEmployee(employee)
  } else { //Update
    const res = await employeeService.updateEmployee(employee)
  }
  await getEmployees()
  loadingStore.finish()
}

async function deleteEmployee(employee: Employee) {
  loadingStore.doLoad()
  const res = await employeeService.delEmployee(employee)
  await getEmployees()
  loadingStore.finish()
}

onMounted(() => {
  getEmployees()
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="Employees">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(173, 105, 53)">
          <v-toolbar-title>Employee</v-toolbar-title>
          <!-- ตรงนี้เป็นช่องค้นหา -->
          <v-text-field v-model="input" density="compact" variant="solo" label="Search Name/Phone number"
            append-inner-icon="mdi-magnify" single-line hide-details @click:append-inner="extra"
            @keyup.enter="extra()"></v-text-field>
          <!-- ตรงนี้เป็นปุ่มรีนะ -->
          <v-btn icon="mdi-cached" color="text-black" @click="getEmployees"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- ใส่Dialog -->
          <SalaryDialog />

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn prepend-icon="mdi-plus" outlined v-bind="props" style="color: white; background-color: green">
                New Employee
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Employee Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="editedEmployee.name" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Name">
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="editedEmployee.tel" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Tel">
                        </v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-combobox v-model="editedEmployee.status" :items="[
                          { title: 'PartTime', value: 'PartTime' },
                          { title: 'FullTime', value: 'FullTime' }
                        ]" label="Select status" multiple :return-object="false">
                        </v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="editedEmployee.salary" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="Salary">
                        </v-text-field>
                      </v-col>
                    </v-row>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="editedEmployee.dateIn" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="DateIn">
                        </v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="editedEmployee.checkIn" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="CheckIn">
                        </v-text-field>
                      </v-col>
                      <v-col>
                        <v-text-field v-model="editedEmployee.checkOut" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" clearable label="CheckOut">
                        </v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="getEmployees"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
